Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.sound.midi
Class Track

    java.lang.Object
      |
      +--javax.sound.midi.Track

public class Track
extends Object

A MIDI track is an independent stream of MIDI events (time-stamped MIDI data) that can be stored along with other tracks in a standard MIDI file. The MIDI specification allows only 16 channels of MIDI data, but tracks are a way to get around this limitation. A MIDI file can contain any number of tracks, each containing its own stream of up to 16 channels of MIDI data.

A `Track` occupies a middle level in the hierarchy of data played by a ``Sequencer``: sequencers play sequences, which contain tracks, which contain MIDI events. A sequencer may provide controls that mute or solo individual tracks.

The timing information and resolution for a track is controlled by and stored in the sequence containing the track. A given `Track` is considered to belong to the particular ``Sequence`` that maintains its timing. For this reason, a new (empty) track is created by calling the ``Sequence.createTrack()`` method, rather than by directly invoking a `Track` constructor.

The `Track` class provides methods to edit the track by adding or removing `MidiEvent` objects from it. These operations keep the event list in the correct time order. Methods are also included to obtain the track's size, in terms of either the number of events it contains or its duration in ticks.

See Also:
  `Sequencer.setTrackMute(int, boolean)`, `Sequencer.setTrackSolo(int, boolean)`

Field Summary
`protected Vector` | `events` The list of `MidiEvents` contained in this track.

Method Summary
`boolean` | `add(MidiEvent event)` Adds a new event to the track.
`MidiEvent` | `get(int index)` Obtains the event at the specified index.
`boolean` | `remove(MidiEvent event)` Removes the specified event from the track.
`int` | `size()` Obtains the number of events in this track.
`long` | `ticks()` Obtains the length of the track, expressed in MIDI ticks.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### events

    protected Vector events

  The list of `MidiEvents` contained in this track.

Method Detail

### add

    public boolean add(MidiEvent event)

  Adds a new event to the track. However, if the event is already contained in the track, it is not added again. The list of events is kept in time order, meaning that this event inserted at the appropriate place in the list, not necessarily at the end.
  Parameters:
    `event` - the event to add
  Returns:
    `true` if the event did not already exist in the track and was added, otherwise `false`

### remove

    public boolean remove(MidiEvent event)

  Removes the specified event from the track.
  Parameters:
    `event` - the event to remove
  Returns:
    `true` if the event existed in the track and was removed, otherwise `false`

### get

    public MidiEvent get(int index)
                  throws ArrayIndexOutOfBoundsException

  Obtains the event at the specified index.
  Parameters:
    `index` - the location of the desired event in the event vector
  Throws:
    ``ArrayIndexOutOfBoundsException`` - if the specified index is negative or not less than the current size of this track.
  See Also:
    `size()`

### size

    public int size()

  Obtains the number of events in this track.
  Returns:
    the size of the track's event vector

### ticks

    public long ticks()

  Obtains the length of the track, expressed in MIDI ticks. (The duration of a tick in seconds is determined by the timing resolution of the `Sequence` containing this track, and also by the tempo of the music as set by the sequencer.)
  Returns:
    the duration, in ticks
  See Also:
    `Sequence.Sequence(float, int)`, `Sequencer.setTempoInBPM(float)`, `Sequencer.getTickPosition()`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2001 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.